
#include "pmacros.h"
#include "system.h"

#include <stdio.h>
#include <sched.h>
#include <stdlib.h>
#include <string.h>
#include <semaphore.h>
#include <errno.h>

#include "redundancy.h"
#include "returncode.h"


int read_sensor1(void* arg) {
   printf("Call sensor1, val = 100\n"); 
   return 100;
}
int val=98;
int read_sensor2(void* arg) {
   printf("Call sensor2, val = %d\n", val+1); 
   val++;
   return val;
}
int read_sensor3(void* arg) {
   printf("Call sensor3, val = 100\n"); 
   return 100;
}




void* POSIX_Init(void *argument)
{

 int status;
 int my_result;
 int diff;

 pthread_redundancy_attr_t attr;
 pthread_redundancy_t      red;
 voter_type func [3];

 pthread_redundancy_attr_init(&attr);
 pthread_redundancy_attr_setpriority(&attr, 100);
 pthread_redundancy_attr_setsize(&attr, 3);

 func[0]=read_sensor1; func[1]=read_sensor2; func[2]=read_sensor3;
 status=pthread_redundancy_init(&red, attr, func, NULL);
 if(status!=0)
     returncode("pthread_redundancy_init init.c",status);


 diff=pthread_redundancy_vote(&red, &my_result);
 if(status!=0)
     returncode("pthread_redundancy_vote init.c",status);
 printf("my_result = %d and diff = %d\n", my_result, diff);
 
 diff=pthread_redundancy_vote(&red, &my_result);
 if(status!=0)
     returncode("pthread_redundancy_vote init.c",status);
 printf("my_result = %d and diff = %d\n", my_result, diff);

 pthread_redundancy_destroy(&red);
 printf("init.c is completed\n");
 pthread_exit(NULL);
 return 0; 
}



